<?php
/**
 * Clase Base FN para BasePlaEmpresaFN
 *
 * @package    
 * @subpackage BasePlaEmpresaFN
 * @author     Willy
 * @version    SVN:: BasePlaEmpresaFN.class.php,v 1.1 2022-07-25 11:36:58 william.taype Exp $
 */
class BasePlaEmpresaFN extends PlaEmpresaBN
{
  private static $fieldNames = array (
    'IdEmpresa'=>'IdEmpresa', 'Descripcion'=>'Descripcion', 'RUC'=>'RUC', 'RutaLogo'=>'RutaLogo', 'Estado'=>'Estado', 'FechaCreacion'=>'FechaCreacion', 'UsuarioCreacion'=>'UsuarioCreacion', 'FechaModificacion'=>'FechaModificacion', 'UsuarioModificacion'=>'UsuarioModificacion', 'Eliminado'=>'Eliminado', 'UsuarioEliminado'=>'UsuarioEliminado', 'FechaEliminado'=>'FechaEliminado'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT IdEmpresa, Descripcion, RUC, RutaLogo, Estado, FechaCreacion, UsuarioCreacion, FechaModificacion, UsuarioModificacion, Eliminado, UsuarioEliminado, FechaEliminado FROM pla_empresa WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT IdEmpresa, Descripcion, RUC, RutaLogo, Estado, FechaCreacion, UsuarioCreacion, FechaModificacion, UsuarioModificacion, Eliminado, UsuarioEliminado, FechaEliminado FROM pla_empresa WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdEmpresa()){ $where .= " AND idempresa = '".$this->getIdEmpresa()."'"; }
      if($this->getDescripcion()){ $where .= " AND descripcion = '".$this->getDescripcion()."'"; }
      if($this->getRUC()){ $where .= " AND ruc = '".$this->getRUC()."'"; }
      if($this->getRutaLogo()){ $where .= " AND rutalogo = '".$this->getRutaLogo()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getFechaCreacion()){ $where .= " AND fechacreacion = '".$this->getFechaCreacion()."'"; }
      if($this->getUsuarioCreacion()){ $where .= " AND usuariocreacion = '".$this->getUsuarioCreacion()."'"; }
      if($this->getFechaModificacion()){ $where .= " AND fechamodificacion = '".$this->getFechaModificacion()."'"; }
      if($this->getUsuarioModificacion()){ $where .= " AND usuariomodificacion = '".$this->getUsuarioModificacion()."'"; }
      if($this->getEliminado()){ $where .= " AND eliminado = '".$this->getEliminado()."'"; }
      if($this->getUsuarioEliminado()){ $where .= " AND usuarioeliminado = '".$this->getUsuarioEliminado()."'"; }
      if($this->getFechaEliminado()){ $where .= " AND fechaeliminado = '".$this->getFechaEliminado()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdEmpresa, Descripcion, RUC, RutaLogo, Estado, FechaCreacion, UsuarioCreacion, FechaModificacion, UsuarioModificacion, Eliminado, UsuarioEliminado, FechaEliminado FROM pla_empresa WHERE 1 AND IdEmpresa='".$this->getIdEmpresa()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BasePlaEmpresaFN = new BasePlaEmpresaFN();
    $o_BasePlaEmpresaFN->setIdEmpresa($o_propel->IdEmpresa);
    $o_BasePlaEmpresaFN->setDescripcion($o_propel->Descripcion);
    $o_BasePlaEmpresaFN->setRUC($o_propel->RUC);
    $o_BasePlaEmpresaFN->setRutaLogo($o_propel->RutaLogo);
    $o_BasePlaEmpresaFN->setEstado($o_propel->Estado);
    $o_BasePlaEmpresaFN->setFechaCreacion($o_propel->FechaCreacion);
    $o_BasePlaEmpresaFN->setUsuarioCreacion($o_propel->UsuarioCreacion);
    $o_BasePlaEmpresaFN->setFechaModificacion($o_propel->FechaModificacion);
    $o_BasePlaEmpresaFN->setUsuarioModificacion($o_propel->UsuarioModificacion);
    $o_BasePlaEmpresaFN->setEliminado($o_propel->Eliminado);
    $o_BasePlaEmpresaFN->setUsuarioEliminado($o_propel->UsuarioEliminado);
    $o_BasePlaEmpresaFN->setFechaEliminado($o_propel->FechaEliminado);
    return $o_BasePlaEmpresaFN;
  }
}